# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`coturn`](#coturn): Install and configure Coturn

## Classes

### coturn

Install and configure Coturn

#### Examples

##### 

```puppet
class { 'coturn':
  realm =>  'example.com',
}
```

#### Parameters

The following parameters are available in the `coturn` class.

##### `realm`

Data type: `Stdlib::Fqdn`

Name (fully qualified domain name) of the Coturn server

##### `listening_ips`

Data type: `Array[Stdlib::IP::Address]`

Listener IP addresses of relay server. Multiple listeners can be specified.
If no IP(s) specified, then all IPv4 and IPv6 system IPs will be used for listening.

Default value: []

##### `listening_port`

Data type: `Stdlib::Port`

TURN listener port for UDP and TCP (plain).

Default value: 3478

##### `tls_listening_port`

Data type: `Optional[Stdlib::Port]`

TURN listener port for TLS
The TURN server "automatically" recognizes the type of traffic.
Actually, two listening endpoints (the "plain" one and the "tls" one) are equivalent
in terms of functionality. Keeping both endpoints satisfy the RFC 5766 specs.

Default value: `undef`

##### `cert`

Data type: `Optional[Stdlib::Absolutepath]`

The certificate file use with TLS.

Default value: `undef`

##### `private_key`

Data type: `Optional[Stdlib::Absolutepath]`

The private key file use with TLS.

Default value: `undef`

##### `fingerprint`

Data type: `Boolean`

Use fingerprints in the TURN messages

Default value: `false`

##### `lt_cred_mech`

Data type: `Boolean`

Use long-term credential mechanism

Default value: `false`

##### `use_auth_secret`

Data type: `Boolean`

Turn on secret-based authentication.

Default value: `false`

##### `static_auth_secret`

Data type: `Optional[String]`

When use_auth_secret is true, secret used for secret-based authentication; typically a long hexadecimal string.

Default value: `undef`

##### `total_quota`

Data type: `Integer[0]`

Total allocation quota

Default value: 0

##### `bps_capacity`

Data type: `Integer[0]`

Maximum server capacity.
Total bytes-per-second bandwidth the TURN server is allowed to allocate
for the sessions, combined (input and output network streams are treated separately).

Default value: 0

##### `stale_nonce`

Data type: `Integer[0]`

Add for extra security. Set this option to limit the nonce lifetime, in seconds.
After the delay, the client will get 438 error and will have to re-authenticate itself

Default value: 600

##### `no_stdout_log`

Data type: `Boolean`

Flag to prevent stdout log messages.
By default, all log messages are going to both stdout and to
the configured log file. With this option everything will be
going to the configured log only (unless the log file itself is stdout).

Default value: `false`

##### `no_loopback_peers`

Data type: `Boolean`

Flag that can be used to disallow peers on the loopback addresses (127.x.x.x and ::1).
This is an extra security measure.

Default value: `false`

##### `no_multicast_peers`

Data type: `Boolean`

Flag that can be used to disallow peers on well-known broadcast addresses (224.0.0.0 and above, and FFXX:*).
This is an extra security measure.

Default value: `false`

##### `dh2066`

Data type: `Boolean`

Use 2066 bits predefined DH TLS key. Default size of the key is 1066.

Default value: `false`

##### `tlsv1`

Data type: `Boolean`

Allow an TLS/DTLS version of protocol v1

Default value: `false`

##### `tlsv1_1`

Data type: `Boolean`

Allow an TLS/DTLS version of protocol v1.1

Default value: `false`

##### `simple_log`

Data type: `Boolean`

This flag means that no log file rollover will be used, and the log file
name will be constructed as-is, without PID and date appendage.

Default value: `false`

